<?php
// SharedMemDataFetcher class
// (c) schmidi 2013 
// www.doh-nuts.at 

require_once('classes.inc.php');

class SharedMemDataFetcher extends DataFetcher {
 	private $id;
 	private $shm_id;

		
	// constructor
	function __construct($id, $timeout=60) {
		$this->id = abs(crc32($id));
		$this->shm_id = false;
		$this->timeout = $timeout;
	}


	function fetchData() {
		if (!$this->shm_id) {
			if (!$this->shm_id = @shmop_open($this->id, 'a', 0644, 164)) {
				return $this->returnBackup();
			}
		}		
		
		// read bin-data
    if(!$dat = @shmop_read($this->shm_id, 0, 164)) {
      // read failed
    	$this->shm_id = false;
      return $this->returnBackup();
    }

 		$dat = unpack('Lt/a30l/a75n/a30i/cp/cpm/cs/csm/Lll/Llu', $dat);
    	
    // timed out?
   	if ($dat['t'] + $this->timeout < time()) {
   		return $this->returnBackup();
   	}
    	
    $this->backup = new ServerObj($dat['l'], $dat['n'], $dat['i'], $dat['p'], $dat['pm'], $dat['s'], $dat['sm'], $dat['ll'], $dat['lu']);
    $this->time = time();	
  	return $this->backup;
	}	

	
	function __toString() {
		return "{$this->id} / {$this->shm_id}";
	}
	
}

?>